//-----------------------------------------------------------------
// SXLCD Firmware di test
// Versione : 1.0
// Area SX
// http://www.areasx.com
// Note     :
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Questo firmware vuole essere solamente un test per il funzionamento
// della scheda SXLCD. Le routine di trasmissione non sono pertanto
// ottimizzate, al fine di mantenere il pi semplice possibile 
// l'invio dei comandi.
// Per utilizzare il firmware occorre collegare la scheda SXLCD al 
// connettore JP6 della scheda SX3000, tramite un cavo piatto a 10 poli
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Buffer delle seriali
//-----------------------------------------------------------------
#define DINBUFSIZE 63
#define DOUTBUFSIZE 63


//-----------------------------------------------------------------
// Prototipi delle funzioni
//-----------------------------------------------------------------
void msDelay(unsigned int);
void BoardInit(void);

// -----------------------------------------------------------------------
// Globali
// -----------------------------------------------------------------------
char TxBuf[60];


//--------------------------------------------------------
// Ritardo bloccante
// Riceve      : ams - numero di millisecondi da ritardare
// Restituisce : -
// Note        :
//--------------------------------------------------------
nodebug
void msDelay(unsigned int ams)
{
  auto unsigned long t0;
  for(t0=MS_TIMER; MS_TIMER<ams+t0;);
}


//--------------------------------------------------------
// Inizializza i port del modulo RCM3700
// Riceve      : -
// Restituisce : -
// Note        :
//--------------------------------------------------------
void BoardInit() {

  // Inizializzazione port PB0 in ingresso (pulsante)
  BitWrPortI(PBDDR, &PBDDRShadow, 0,0);

  // Inizializzazione port PB2 (Led 1)
  BitWrPortI(PBDDR, &PBDDRShadow, 1,2);

  // Inizializzazione port PB3 PB4 PB5 PB7 (Analogica)
  BitWrPortI(PBDDR, &PBDDRShadow, 1,3);
  BitWrPortI(PBDDR, &PBDDRShadow, 1,4);
  BitWrPortI(PBDDR, &PBDDRShadow, 1,5);
  BitWrPortI(PBDDR, &PBDDRShadow, 0,7);

  // Inizializzazione port PE5 e PE7 (Led 2 e 3)
  WrPortI(PEFR, &PEFRShadow,0 );
  BitWrPortI(PEDDR, &PEDDRShadow, 1,5);
  BitWrPortI(PEDDR, &PEDDRShadow, 1,7);

  // Inizializzazione port PG6 (Seriale E)
  BitWrPortI(PGFR, &PGFRShadow, 1,6);

  // Inizializzazione seriale su PC2-PC3 (Ser C)
  BitWrPortI(PCFR, &PCFRShadow, 1,2);
  // Inizializzazione seriale su PC0-PC1 (Ser D)
  BitWrPortI(PCFR, &PCFRShadow, 1,0);

  // Inizializzazione port PF0 PF1 per il controllo di flusso
  WrPortI(PFFR, &PFFRShadow, 0x00);
  WrPortI(PFDCR, &PFDCRShadow, 0x00);
  BitWrPortI(PFDDR, &PFDDRShadow, 1,0);
  BitWrPortI(PFDDR, &PFDDRShadow, 0,1);


}



// -----------------------------------
// Loop Principale
// -----------------------------------
main () {

  char ch;
  int i,j;
  int ADRes;
  char cmd;
  char addr;
  char data1;
  char data2;
  char s[100];
  char msg[100];
  char len;

  BoardInit();


  // Inizializza la porta seriale a 19200 baud
  serDopen(19200);


  printf ("Inizio test scheda SXLCD. Versione 1.0\n");

  while(1) {

		  printf("\nInserisci l'indirizzo del display (invio per broadcast): ");
		  gets(s);

		  if (strlen(s)) {
		    addr = atoi(s);
		  } else {
		    addr=0xFF;
		  }

      printf("\n0 - Undocumented Ver");
      printf("\n1 - Cancella display ");
      printf("\n2 - Scrivi messaggio");
      printf("\n3 - Scrivi messaggi in posizione");
      printf("\n4 - Imposta Backlight");
      printf("\n5 - Imposta indirizzo");
      printf("\n6 - Imposta cursore");
      printf("\n7 - Configura display");
      printf("\n8 - Imposta il Wrap Mode");
      
      printf("\n\n99 - BL Ramp");
		  printf("\nInserisci il comando da inviare: ");
		  gets(s);
		  cmd = atoi(s);

		  switch (cmd) {

		  case 0x00:
		    printf ("->COMANDO: FW Version\n");
		    data1=0;
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x01:
		    printf ("->COMANDO: Cancella display\n");
		    data1=0;
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x02:
		    printf ("->COMANDO: Scrivi messaggio\n");
		    printf("\nInserisci messaggio da inviare: ");
		    gets(s);
		    data1=0;
		    data2=0;
		    sprintf(msg,"%s",s);
		    break;

		  case 0x03:
		    printf ("->COMANDO: Scrivi messaggio in posizione\n");

		    printf("\nPosizione X (0-19): ");
		    gets(s);
		    data1 = atoi(s);

		    printf("\nPosizione Y (0-3): ");
		    gets(s);
		    data2 = atoi(s);

		    printf("\nInserisci messaggio da inviare: ");
		    gets(s);
		    sprintf(msg,"%s",s);

		    break;

		  case 0x04:
		    printf ("->COMANDO: Imposta Livello backlight\n");
		    printf("\n0 - Spenta, 1 - 255 parzializzata: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");

		    break;

		  case 0x05:
		    printf ("->COMANDO: Imposta indirizzo display\n");
		    printf("\nNuovo indirizzo (1-254): ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x06:
		    printf ("->COMANDO: Imposta cursore\n");
		    printf("\n0 - No Cursor ,1 - Cursore fisso, 2- cursore lampeggiante: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x07:
		    printf ("->COMANDO: Configurazione Display\n");

		    printf("\nIndirizzo Riga 1: ");
		    gets(s);
		    data1 = atoi(s);

		    printf("\nIndirizzo Riga 2: ");
		    gets(s);
		    data2 = atoi(s);
		    
		    printf("\nIndirizzo Riga 3 (255 per nessuno): ");
		    gets(s);
		    msg[0] = atoi(s);

		    printf("\nIndirizzo Riga 4 (255 per nessuno): ");
		    gets(s);
		    msg[1] = atoi(s);

		    printf("\nNumero di righe e colonne (YYYXXXXX) : ");
		    gets(s);
		    msg[2] = atoi(s);		    
		    
		    msg[3]=0;
		    break;

		  case 0x08:
		    printf ("->COMANDO: Imposta Wrap Mode (a capo automatico)\n");
		    printf("\n0 - No Wrap Mode ,1 - Wrap Abilitato: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

      case 99:
		    printf ("->COMANDO: Rampa backlight\n");
		    printf("\nStep di rampa: ");
		    gets(s);
		    data1 = atoi(s);
      
        for (j=0;j<255;j+=data1) {
          
          TxBuf[0]='>';
          TxBuf[1]=0xFF; // ADDRESS
          TxBuf[2]=0x04;  //Write AT CMD
          TxBuf[3]=j;     //Write AT D1
          TxBuf[4]=0;     //Write AT D2
          TxBuf[5]=0;

          printf ("Set BL [%d]\n",j);
          for (i=0;i<len;i++) {            
            serDputc(TxBuf[i]);
          }          
          msDelay(50);
        }

        for (j=255;j>0;j-=data1) {
          
          TxBuf[0]='>';
          TxBuf[1]=0xFF; // ADDRESS
          TxBuf[2]=0x04;  //Write AT CMD
          TxBuf[3]=j;     //Write AT D1
          TxBuf[4]=0;     //Write AT D2
          TxBuf[5]=0;

          printf ("Set BL [%d]\n",j);
          for (i=0;i<len;i++) {            
            serDputc(TxBuf[i]);
          }          
          msDelay(50);          
        }

		  }
      
      if (cmd!=99) {
        TxBuf[0]='>';
        TxBuf[1]=addr;      // ADDRESS
        TxBuf[2]=cmd;       //Write AT CMD
        TxBuf[3]=data1;     //Write AT D1
        TxBuf[4]=data2;     //Write AT D2
        for (i=0;i<strlen(msg);i++) {
          TxBuf[5+i]=msg[i];
        }
        TxBuf[5+i]=0x00;
        len=5+i+1;
  
        printf ("Invio comando\n");
  
        for (i=0;i<len;i++) {
          printf ("[%02x]",TxBuf[i]);
          serDputc(TxBuf[i]);
        }
  
        printf ("\n\n");
  
        msDelay(100);
      }

  }
}